package agent

import (
	"gitlab.com/gitlab-org/cluster-integration/gitlab-agent/v18/internal/module/google_profiler"
	"gitlab.com/gitlab-org/cluster-integration/gitlab-agent/v18/internal/module/modagent"
)

type Factory struct {
}

func (f *Factory) IsProducingLeaderModules() bool {
	return false
}

func (f *Factory) New(config *modagent.Config) (modagent.Module, error) {
	return &module{
		log: config.Log,
		runner: &googleProfilerRunner{
			service: config.AgentName,
			version: config.AgentMeta.Version,
		},
	}, nil
}

func (f *Factory) Name() string {
	return google_profiler.ModuleName
}
